import numpy as np
from math import sqrt,log, erf, erfc
import matplotlib.pyplot as plt
from scipy.special import comb
from decimal import *

q=251


def error_lac128( ):
    n=512
    d=2*n
    res=np.zeros(2*d+1,np.dtype(Decimal))
    pre=np.zeros(2*d+1,np.dtype(Decimal))
    p_zero=Decimal(1/2.)
    p_one=Decimal(1/4.)
    pre[d]=p_zero+p_one*p_zero*2
    pre[d-1]=p_one*p_one*2
    pre[d+1]=p_one*p_one*2
    loop=int(log(d,2))
   #se_1+re
    for i in range(loop): 
        start=d-2**i
        end=d+2**i
        res=np.zeros(2*d+1,np.dtype(Decimal))
        for j in range(start,end+1):
            for k in range(start,end+1):
                res[j+k-d]=res[j+k-d]+pre[j]*pre[k]
               
        pre=res.copy()
    #+e_2
    e2_array= np.zeros(3,np.dtype(Decimal))
    e2_array[0]=Decimal(1/4.)
    e2_array[1]=Decimal(1/2.)
    e2_array[2]=Decimal(1/4.)
    res_2=np.zeros(2*d+3,np.dtype(Decimal))
    for i in range(3):
        for j in range(2*d+1):
            res_2[i+j]=res_2[i+j]+e2_array[i]*res[j]
    #+rounding errors
    round_error=np.zeros(15,np.dtype(Decimal))
    for i in range(15):
        round_error[i]=Decimal(1/15.)
    res_3=np.zeros(2*d+17,np.dtype(Decimal))

    for i in range(15):
        for j in range(2*d+3):
            res_3[i+j]=res_3[i+j]+round_error[i]*res_2[j]

    #evaluate Pr[-q/4,q/4]
    error_rate=Decimal(0)
    start=d+8-62
    end=d+8+62
    for i in range (start,end+1):
        error_rate=error_rate+res_3[i]
            
    return 1-error_rate

def error_lac192( ):
    n=1024
    d=2*n
    res=np.zeros(2*d+1,np.dtype(Decimal))
    pre=np.zeros(2*d+1,np.dtype(Decimal))
    p_zero=Decimal(3/4.)
    p_one=Decimal(1/8.)
    pre[d]=p_zero+p_one*p_zero*2
    pre[d-1]=p_one*p_one*2
    pre[d+1]=p_one*p_one*2
    loop=int(log(d,2))
   #se_1+re
    for i in range(loop): 
        start=d-2**i
        end=d+2**i
        res=np.zeros(2*d+1,np.dtype(Decimal))
        for j in range(start,end+1):
            for k in range(start,end+1):
                res[j+k-d]=res[j+k-d]+pre[j]*pre[k]
               
        pre=res.copy()
    #+e_2
    e2_array= np.zeros(3,np.dtype(Decimal))
    e2_array[0]=Decimal(1/8.)
    e2_array[1]=Decimal(3/4.)
    e2_array[2]=Decimal(1/8.)
    res_2=np.zeros(2*d+3,np.dtype(Decimal))
    for i in range(3):
        for j in range(2*d+1):
            res_2[i+j]=res_2[i+j]+e2_array[i]*res[j]
    #+rounding errors
    round_error=np.zeros(15,np.dtype(Decimal))
    for i in range(15):
        round_error[i]=Decimal(1/15.)
    res_3=np.zeros(2*d+17,np.dtype(Decimal))

    for i in range(15):
        for j in range(2*d+3):
            res_3[i+j]=res_3[i+j]+round_error[i]*res_2[j]

    #evaluate Pr[-q/4,q/4]
    error_rate=Decimal(0)
    start=d+8-62
    end=d+8+62
    for i in range (start,end+1):
        error_rate=error_rate+res_3[i]
            
    return 1-error_rate

def error_lac256( ):
    n=1024
    d=2*n
    res=np.zeros(2*d+1,np.dtype(Decimal))
    pre=np.zeros(2*d+1,np.dtype(Decimal))
    p_zero=Decimal(1/2.)
    p_one=Decimal(1/4.)
    pre[d]=p_zero+p_one*p_zero*2
    pre[d-1]=p_one*p_one*2
    pre[d+1]=p_one*p_one*2
    loop=int(log(d,2))
   #se_1+re
    for i in range(loop): 
        start=d-2**i
        end=d+2**i
        res=np.zeros(2*d+1,np.dtype(Decimal))
        for j in range(start,end+1):
            for k in range(start,end+1):
                res[j+k-d]=res[j+k-d]+pre[j]*pre[k]
               
        pre=res.copy() 
    #+e_2
    e2_array= np.zeros(3,np.dtype(Decimal))
    e2_array[0]=Decimal(1/4.)
    e2_array[1]=Decimal(1/2.)
    e2_array[2]=Decimal(1/4.)
    res_2=np.zeros(2*d+3,np.dtype(Decimal))
    for i in range(3):
        for j in range(2*d+1):
            res_2[i+j]=res_2[i+j]+e2_array[i]*res[j]
    #+rounding errors
    round_error=np.zeros(15,np.dtype(Decimal))
    for i in range(15):
        round_error[i]=Decimal(1/15.)
    res_3=np.zeros(2*d+17,np.dtype(Decimal))

    for i in range(15):
        for j in range(2*d+3):
            res_3[i+j]=res_3[i+j]+round_error[i]*res_2[j]

     #d2 code
    res_4=np.zeros(4*d+33,np.dtype(Decimal))
    for i in range(2*d+17):
        for j in range(2*d+17):
            res_4[i+j]=res_4[i+j]+res_3[i]*res_3[j]
            
    #evaluate Pr[-q/2,q/2]
    error_rate=Decimal(0)
    start=2*(d+8)-125
    end=2*(d+8)+125
    for i in range (start,end):
        error_rate=error_rate+res_4[i]
            
    return 1-error_rate

def log_comb(x,k):
    sum=0.
    for i in range(x-k+1,x+1):
        sum=sum+log(i,2)

    for i in range(1,k+1):
        sum=sum-log(i,2)

    return sum

def main():

    print "exact error rate estimation may take a long time, please wait....."
    #exact estimate of single bit error
    print "error rate of each bit by exact estimate with rounding errors"
    
    delta1=float(error_lac128())
    delta2=float(error_lac192())
    delta3=float(error_lac256())
    
#    delta1=2**(-12.6148405261)
#    delta2=2**(-22.2742524265)
#    delta3=2**(-12.9637946025)
    print "LAC128:", log(delta1,2)
    print "LAC192:", log(delta2,2)
    print "LAC256:", log(delta3,2)
    """
    #estimate single bit error rate by central limit theory
    print "error rate of each bit by central limit theory"
    delta1=erfc((q/4)/(sqrt(2*2*512)*sigma1**2))
    delta2=erfc((q/4)/(sqrt(2*2*1024)*sigma2**2))
    delta3=erfc((q/4)/(sqrt(2*2*1024)*sigma3**2))
    print "LAC128:", log(delta1,2)
    print "LAC192:", log(delta2,2)
    print "LAC256:", log(delta3,2)
    """
    #error rate
    print "decryption error rate "
    l_n=511
    l_t=16
    l_max=367
    l_m=l_n-l_max+256
    Delta1=0
    for i in range(l_t+1,l_m+1):
        Delta1=Delta1+comb(l_m,i)*(delta1**i)*((1-delta1)**(l_m-i))
    print "LAC128:", log(Delta1,2)

    l_n=511
    l_max=439
    l_t=8
    l_m=l_n-l_max+256
    Delta2=0
    for i in range(l_t+1,l_m+1):
        Delta2=Delta2+comb(l_m,i)*(delta2**i)*((1-delta2)**(l_m-i))
    print "LAC192:", log(Delta2,2)
    
    l_n=511
    l_max=367
    l_t=16
    l_m=l_n-l_max+256
    Delta3=0
    for i in range(l_t+1,l_m+1):
        Delta3=Delta3+comb(l_m,i)*(delta3**i)*((1-delta3)**(l_m-i))
    print "LAC256:", log(Delta3,2)

if __name__ == '__main__':
    main()




