#ifndef kem_api_h
#define kem_api_h
#include <stdint.h>

#include  "lac_param.h"

#define KEM_SECRETKEYBYTES DIM_N+PK_LEN
#define KEM_PUBLICKEYBYTES PK_LEN
#define KEM_BYTES MESSAGE_LEN
#define KEM_CIPHERTEXTBYTES CIPHER_LEN
#define KEM_ALGNAME "LAC-KEM"

//functions for kem
int kem_keygen( unsigned char *pk, unsigned char *sk);
int kem_enc(unsigned char *pk, unsigned char *ss, unsigned char *ct);
int kem_dec(unsigned char *sk, unsigned char *ct, unsigned char *ss);

int kem_enc_fo(const unsigned char *pk, unsigned char *k, unsigned char *c);
// fo encryption for cca security with seed
int kem_enc_fo_seed(const unsigned char *pk, unsigned char *k, unsigned char *c, unsigned char *seed);
// decrypt of fo mode
int kem_dec_fo(const unsigned char *pk, const int8_t *sk, const  unsigned char *c, unsigned char *k);

#endif /* kem_api_h */
