#ifndef pke_api_h
#define pke_api_h
#include <stdint.h>

#include  "lac_param.h"

#define PKE_SECRETKEYBYTES DIM_N+PK_LEN
#define PKE_PUBLICKEYBYTES PK_LEN
#define PKE_BYTES MESSAGE_LEN
#define PKE_CIPHERTEXTBYTES CIPHER_LEN
#define PKE_ALGNAME "LAC-PKE"

// Change the algorithm name
#define CRYPTO_ALGNAME STRENGTH
//functions for pke
int pke_keygen( unsigned char *pk, unsigned char *sk);
int pke_enc(unsigned char *pk, unsigned char *m, unsigned long long mlen, unsigned char *c, unsigned long long *clen);
int pke_dec(unsigned char *sk, unsigned char *c, unsigned long long clen, unsigned char *m, unsigned long long *mlen);

//key generation
int kg(unsigned char *pk, int8_t *sk);
//key generation with seed
int kg_seed(unsigned char *pk, int8_t *sk, unsigned char *seed);
// encryption
int enc(const unsigned char *pk, const unsigned char *m, unsigned long long mlen, unsigned char *c, unsigned long long *clen);
// encryption with seed
int enc_seed(const unsigned char *pk, const unsigned char *m, unsigned long long mlen, unsigned char *c, unsigned long long *clen, unsigned char *seed);
// decrypt
int dec(const int8_t *sk, const unsigned char *c, unsigned long long clen, unsigned char *m, unsigned long long *mlen);

#endif /* pke_api_h */
